library nueli.core.util;

import 'dart:math';
import 'dart:ui';

import 'package:flutter/cupertino.dart';
import 'package:flutter/gestures.dart';
import 'package:flutter/material.dart';
import 'package:nueli/nueli.dart';

import '../bucket/--bucket.dart';
import '../data.dart';

part 'decor.dart';
part 'icon.dart';
part 'ink.dart';
part 'matrix.dart';
part 'radii.dart';
part 'shadow.dart';
part 'text.dart';
part 'tranx.dart';

typedef Configure = Config Function(Config config);

abstract class Config<T extends Config<T, Data, Output>, Data, Output> with OR<T>, Subtract<T>, Add<T> {
  Data get data;
  set data(Data data);
  T operator *(double factor);
  T operator &(Data data) => this..data = data ?? this.data;
  Output get compile;
  Widget build({Data data, Data fallback});
}

class ConfigTween<T extends Config<T, dynamic, dynamic>> extends Tween<T> {
  final T begin;
  final T end;
  ConfigTween(this.begin, this.end);
}

class ConfigTransition<T extends Config<T, dynamic, dynamic>> extends AnimatedWidget {
  final Configure configure;

  ConfigTransition({Key key, Animation<T> config, this.configure}) : super(key: key, listenable: config);

  Animation<T> get config => listenable as Animation<T>;

  @override
  Widget build(BuildContext context) {
    if (configure == null) return config.value.build();
    return configure(config.value).build();
  }
}
