library nueli.ui;

import 'dart:async';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:need_resume/need_resume.dart';

import '../core/--core.dart';

part 'fragment.dart';
part 'screen.dart';
part 'struct.dart';

const ui = const _UITools();

mixin UI {
  static BuildContext _globalContext;
  static BuildContext get globalContext => _globalContext;
  static set globalContext(BuildContext context) => _globalContext = context;

  Widget get empty => _UITools().empty;
  Widget gap(double size) => _UITools().gap(size);
  Widget dot(double size, [Color color]) => _UITools().dot(size, color);
  Widget lineH(double thickness, [Color color]) => _UITools().lineH(thickness, color);
  Widget lineV(double thickness, [Color color]) => _UITools().lineV(thickness, color);
  Expanded flex(int flex) => _UITools().flex(flex);
}

class _UITools {
  static const Widget empty0 = SizedBox();

  const _UITools();

  Widget get empty => empty0;
  Widget gap(double size) => SizedBox(width: size, height: size);
  Widget lineH(double thickness, [Color color]) => Container(
        height: thickness,
        width: double.infinity,
        decoration: $decor.paint(color ?? palette.accent).radii_all(thickness).compile,
      );
  Widget lineV(double thickness, [Color color]) => Container(
        width: thickness,
        height: double.infinity,
        decoration: $decor.paint(color ?? palette.accent).radii_all(thickness).compile,
      );
  Widget dot(double size, [Color color]) => Container(
        width: size ?? 2,
        height: size ?? 2,
        decoration: $decor.paint(color ?? palette.accent).radii_all(size).compile,
      );
  Expanded flex(int flex) => Expanded(child: empty, flex: flex);
}

extension ExpandedUI on Expanded {
  Expanded operator &(Widget child) => Expanded(child: child, key: key, flex: flex);
}
