part of nueli.ui;

mixin Fragment<T extends Screen> on ScreenState<T> {
  Alignment get alignment => Alignment.center;
  DecorConfig get scrim => $decor.paint(palette.shade);
  DecorConfig get decor => $decor.paint(palette.background).radii_all(8).raise(8);

  onClose() {}

  @override
  @protected
  @mustCallSuper
  void onPause() {
    onClose();
    super.onPause();
  }

  /// Do not override
  @override
  double get appBarHeight => 0;

  /// Do not override
  @override
  Widget get appBar => empty;

  /// Do not override
  @override
  Widget frame(Widget content) {
    return GestureDetector(
      onTap: () => close(),
      child: safeRegion(
        withSafeArea: true,
        child: $decor.stretch
            .padding(EdgeInsets.all(50)) // break
            .align(alignment ?? Alignment.center)
            .build(
              child: decor.clip_antiAlias.wrap.build(
                child: GestureDetector(child: content, onTap: () {}),
              ),
            ),
      ),
    );
  }
}
